module.exports = {
  resetMocks: true,
  verbose: true,
  browser: true,
  globals: {
    "DEBUG": true,
    "TARGET": "browser",
    "ts-jest": {
      "tsConfigFile": "tsconfig.json",
    },
  },
  moduleNameMapper: {
    "ivi-scheduler": "<rootDir>/packages/ivi-test-scheduler/src/",
    "ivi-test-scheduler": "<rootDir>/packages/ivi-test-scheduler/src/",
    "ivi-core": "<rootDir>/packages/ivi-core/src",
    "ivi-events": "<rootDir>/packages/ivi-events/src",
    "ivi-gestures": "<rootDir>/packages/ivi-gestures/src",
    "ivi-html": "<rootDir>/packages/ivi-html/src",
    "ivi-svg": "<rootDir>/packages/ivi-svg/src",
    "ivi-test": "<rootDir>/packages/ivi-test/src",
    "ivi-state": "<rootDir>/packages/ivi-state/src",
    "ivi-router": "<rootDir>/packages/ivi-router/src",
    "ivi-math": "<rootDir>/packages/ivi-math/src",
    "ivi": "<rootDir>/packages/ivi/src",
  },
  transform: {
    "\\.ts$": "ts-jest",
  },
  testRegex: "/__tests__/.*\\.spec\\.ts$",
  testPathIgnorePatterns: [
    "/node_modules/",
    "/dist/",
    "\\.snap$",
    "/coverage/",
  ],
  moduleFileExtensions: ["ts", "js", "json"],
  coverageReporters: ["text", "json", "lcov", "html"],
  collectCoverageFrom: [
    "packages/**/src/**/*.ts",
    "!**/node_modules/**",
    "!**/__tests__/**",
    "!packages/ivi-scheduler/**",
    "!packages/ivi-test-scheduler/**",
    "!packages/ivi-test/**",
    "!packages/ivi-router/**",
    "!packages/ivi-math/**",
    "!packages/ivi-gestures/**",
    "!packages/ivi/src/dev_mode/**",
  ],
  coveragePathIgnorePatterns: ["/__tests__/", "/node_modules/"],
  cacheDirectory: ".jest/cache",
};
